package com.github.roschlau.adventofcode.core.solvers.y2022

import com.github.roschlau.adventofcode.core.args
import kotlinx.coroutines.runBlocking
import org.junit.jupiter.api.Assertions
import org.junit.jupiter.params.ParameterizedTest
import org.junit.jupiter.params.provider.MethodSource

class Day3Test {

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part1Args")
    fun `part 1`(input: String, solution: String) = runBlocking {
        Assertions.assertEquals(solution, Day3.solvePart1(input))
    }

    @ParameterizedTest(name = "{0} -> {1}")
    @MethodSource("part2Args")
    fun `part 2`(input: String, solution: String) = runBlocking {
        Assertions.assertEquals(solution, Day3.solvePart2(input))
    }

    @Suppress("unused")
    companion object {
        @JvmStatic
        fun part1Args() = args(
            testInput to "157",
            input to "7716",
        )

        @JvmStatic
        fun part2Args() = args(
            testInput to "70",
            input to "2973",
        )
    }
}

private val testInput = """
    vJrwpWtwJgWrhcsFMMfFFhFp
    jqHRNqRjqzjGDLGLrsFMfFZSrLrFZsSL
    PmmdzqPrVvPwwTWBwg
    wMqvLMZHhHMvwLHjbvcjnnSBnvTQFn
    ttgJtRGJQctTZtZT
    CrZsJsPPZsGzwwsLwLmpwMDw
""".trimIndent()

private val input = """
    ZTmtZvZLTFNLMQMNRvZncdcHwcScJvcdHnVfwV
    zqjqrzqjCqrjtqWhqChqrznhcfdfVnVSVgcffcgJcSgd
    rtDGpzjjqjlrGsWqBWFRsbTPFQMTbRNRFmbs
    FFlnlnVlmQqcBVhBRrSrGSwVdRJbztSt
    NPPNsffWfNztRZSJNG
    WpgpTTHDpgTDDpMLPGgMHslmBmmHcBQnFmcqhmnjlqQm
    VlVNLlPQhtnDRPnP
    QgqTffzZqgvgzWmqqZmGcDthtRFvnnFnhJtJJDDt
    WGTBzSqBQTQmZBWHswpNbswLbSNCNl
    PFzFQDdLjMzzQDhnDNmwZmqwRsmRRmMVNM
    GtSbbtlttvvtBvtHBmqqNqVVwsVgCmRw
    brlvctHfrlrqvGvcTpjDdFnLDhdfjLhQpn
    fTqzgFrcmzTrTNgMzFzTrgtbMtVMVPSLVbvSStRttPVV
    lsHnlQhplQpsHhlDJsswNwZPZZVNwvnSZSVvVS
    BJpsGWhWQQHdGHlpWpfgrmqgNBmTTBqzTrzr
    PLPPrDNHDBnrWNBmjDmjbqqgzjgjQC
    GJpFwpvFFsJpwvwwGwJZJRptzdQSSZTmCjTQmTSQjjZSggQQ
    ffwGGtJGCfLcNMNNfNLW
    nlTzllGwlQHHGMSrrhQLcvbcghgcvL
    fFNpttBRFFRNtJJnfNWmqbhhZrZrcjgpvLrvrvcvbr
    JBftFFsVRWtNWRsmWtRfftGHGPDDCnTDHSCwzwVnwGSw
    LsrZLbLmPSTZtPcc
    zpnpljpdwhRpfNLlPWPtTPcnMWPcctTV
    qlhNNjldqdpgqdfhjpphdsgmmrDBBJJQgHrmDHLQJb
    ndDrsBbpqspHCjzVBCHjMj
    LWFcQFQtVVdcCMHC
    RLthwTWLTSLwTllRLLlLNlPpPGfrGnqDdGqsZqsZsZhb
    jHnJLJrcBbrRHJpnLBBjdHbjfgvGwstwWwdsWWshfhFzFfhv
    PZDQMNTMQwtgvGTGhf
    lqlPPQZQVSQCPSCPDmLppjqRqHngLHjRgLnL
    MfQrhdzNMfMPsNNmPmqPLCLCVLBnbP
    WVtcVvJJVjvFZZmgGjnjLBjmnnHB
    FFtcZRpWJcSDTwlVMhMDwrrDzM
    bSMbrQGZwwqbrbGMdTQGMwQdfFBLDLHLHssDgsHHBJDsFfwL
    lpPPCccvVPvccPzcWLDJFJBsBzJJHsqHjg
    tnqlPlVlNvNZZSSrGGZb
    NlBBBBBwmwcMgLwLVVLLLscHdnMDdbHJCbdvJbPdDDJHvn
    ZRWQWSfGhtSjqZhffZhhRjtdvPFHvCJbFdCFFDdHJdPb
    fpqGhQWWZRhfqRSqrpGllLcVLmscgrLwBmgCzN
    wHHHwDNCzZwzZfpzwsswzfzvnvnMDMgMhMGGFGRVdMnvcF
    mLtttqTPBtSJTSBQWlmcMvVdclnvhFggdGhRdn
    QBLPSLQQWmLtTBtBSjZfsbwbHzpjGzHfpzzw
    zDPBqBPqwzzsqlTzzPzqjttNbCPJVtPCbrvjvCZP
    MFhMhGfFfGpWWpHhFfRpHjVNbDbJjVMjrVvVNtMtbt
    gfRSmpggSFRgfGRphFGgfgBSBTqzSsdlTLqdsnsDBqLw
    QTTdWZZZTrhCZrjhVt
    SBJJNRRvvRpwwspNSpTPjCMVhhtCjGThjBjB
    fJJpvRRwNRSwvzRzRvzSgSRNqFTFDbFmqncQTbdFfnbDQnLW
    wSjwwjWhbhhjWjdqSVpqSndvMdmM
    NTvPBrZgPPHDFrFHGvZHRBqVBpCQVRRdmpRppdqM
    TgDHZPsNTWbbwsjtvw
    HVRPRwJVppQNpGmvMvmqqq
    WcttbWsWsdDdbFDSSWclZGvFLMvfvjfzNvLGzLmfqv
    tglcmSldWlBQBThRQBhg
    LDGGfPFLGsfFnGLfMzfJVccNzmcmwm
    qggSRgtjgCRtdtNZCJMCcZwTZVcm
    RBbHbbRRnLBDDrvN
    pThhMtMtTsWspWTnGjpsVHPdjdjvHdgVvLDVVSjd
    JQNrrwCFrSRLRVLnSN
    JQcJFCfcnfQmrbblQqlthGqzpZpGTBMWTMqtst
    DzVmzDDgsNdHHLGJhJppPPllqSgbql
    jrBWjcQMCRchPShwSblpbW
    ZjRrSCtnnrtBQTcrSZmGtGFFNDHmHVVmVtzz
    GSbGbrTGRRScMlVFjfbqqjdF
    tvDmZhtNtHDttBhCmHDJHNwlpjslMwfflvpqldsFpMlf
    HdBhLDhJDLWWLDCSQGcrQPGccLTGcQ
    tNzrCdJBrrtQdtgQdlQQtrnMZhMTqzHqqTFZZFqTHFMV
    bwbsRDvfwfsfcfSFqMmqDqFVNMNVVH
    PRvfbSjNvPWPlLllLJ
    MjMRRNRMjZtGVGpBCMMCDV
    vwfhFzhvcJQQwJlQSddzQwFWGqcDpCDqBqDTcGZTTVTCWG
    dvFJzrfZJhddLNLPHsrtRbPr
    BmbsFNBhszGgGtGl
    MSHVwdSwZflGlcqqpM
    QvwZCnnnSvZdCSWrNmDlPPBPDhPmjW
    MDwpRzRwMzMsdVSjdMWWMQdW
    gmlftnDtHnHHVWSWBjWjWgvW
    HbtrhbbGRNDpbCDz
    cjVGqQqVqBFhDtvB
    ZnTTfTffZZmDhBtJZG
    fNzbpzlHTlgHNzlRTlRNbHrWwrCwWSSdQddNjwVcjGSd
    WWrPMhwhnjpSLCpDlSSW
    sNGBGdmTbZNGsmbstNLZGZDBRSlqSRCfRSCqRRDDqCqp
    NvvcGtsLdTNZmLTmdJPcnnMFjFMcrVJhMF
    wMRQMSQZHznRsqRbWp
    ddgDDhfDrrDdjthHmdHrzpbVCVWFpfVqCWpWqpFs
    hdvNdHtjMLJZvJwM
    nWzZtWzHzZWgQHMNLDMDfDBfQbdD
    MCPmRGGhqdmNjbDN
    FRPlMlRChCvFggWZsHsZHn
    ZGhhjdgwgcZHsPnRnSnbWscn
    tltlfMQQQftDFJpMQJsWJWJsnWBnRSBbrBWP
    lfLDpQMFMNfLjGjPPgZzwh
    HcmvWcqnHLLPDzPPHM
    MGGSfdJRdCglfrLjrjrLzLPzlF
    CsgRgfwgdCwhsssJBBwvcnQnQNMvQtQm
    nrVbwgnSTSgSnrZpjpWWqmWNHlqqpV
    BcBPhSdsDlHNtNlJNP
    RLFCQLQRRsBDDcRdGDddhCRDfwzvSCnzrbfrMfMgznwwfbZv
    HJLzLNwBNzNJLzBJztRGzQVnDgwsjbgwssZwnDZbDQ
    PhvlSvvPfMRlDbDsggbSjQSg
    mFfhMlMrfchvPPpFTPvMvPzLBHWRHJNtzJGzzHpzBtCC
    FLsgSLzLswdFgLBbWZnJDWHcmZnnBjHM
    rpbrrqfqpvCbqqQQvvpClblRDHmjmmjJJZZnWMJmmJmmcRMc
    qTppQvCfhzSVVTzbdL
    ThTJtlqfDrDtffwqRCFCCnLwdnmpzRdF
    WPQSSFsGMgQZWvFQgZgZQcCdmmzLMLCpNzCCddmLzdzm
    cvVPGPQQGsZsgGPjVFccbHhThJHhDqfhDDjHqDrr
    CgnCCnPMnMtGHDbMFQ
    zLpwpRTwwRwhRchHwmqmGvvGbqmTmNQqvq
    sHdhzlwrRVrdLzRrprrfjgfjVBnBCfSBZZgPfJ
    SPMdWwWPrZwdrrWrSPLFDfgbQDfwDFfFglDQ
    qLGBtGLpjzqmvQbvvpDvfFpR
    jhLqqHBLGjtLqSZCssSTZZMshP
    MhJCpPDpRRFRzQQNNqbcZjNZmVhjNm
    LLSlLnGDmNqLbNjb
    sfBngrBSTTSnSGHlTsHBGsBpFFdRdQPDCFPWRMzzdQWM
    ZQtmgtWfPcgPgcsb
    pvMhFThpHVTvPbcFcFJLJDsd
    MTVHchVVHjHHTcpjMVBjjnQnGqQZnlqBmrWQQBffQQ
    HfcRNJpJfhCmpGSqqGNjsjBnQl
    tTdPwwtLTrrTVPSnQsbGPsnnlFllFQ
    VvvTSTwWMrSZVwwrrmRmczJchHcHCZhRzD
    wfRwhmLRnvrHqHhV
    bJlBHlWlHMBPJzDlzMMJJSBlFnrGVrqspGGvpVGPVpGsVqvp
    DWdStDMztCCHgZCtmZ
    MHdsznVDDfcjcjDcdDjmMSCQwQpCpFCvqSZQqFzQpQ
    lhJnLJJnTNrWTRqvqqPrFwZvwqQp
    NghhtJBtnWLRTNjmcMDtjdsMfGDH
    jgsvPffVmHfDqPSrNwnQwnwNhSvw
    PZbGbCdcGdRCGtntQLQQLLwtpLNw
    RbcPFBRFcdZBBJDBmTHjsD
    dTTFJdzhmmmQpzVz
    jtNLcctGGjtfrnVMsNQNQVVWnv
    GcrcrfLtDggLftDFhZFdJFHJBVFBgZ
    TTbqTgqCqZCrwmhQnnmrgh
    MhpfsMLhfmrznLrQrF
    RsStRMtjpHMfDtWsWsNDppsqlZqBlhNlbcNdTPClPqcvBP
    lRhZPgnpRGZlSrmsLSvSzLVl
    wwHdHCfDQCJHdwdDMdHCcDsLmNVvzVsWrcVNcVzLbrLz
    dMCCwCtJdwDQJMtjhnvhpPhRZBhR
    pBqMZfDffmBnvnNmPt
    rhwLHCChrLPCMNWMCNmW
    GSMVRSVwHLMRJDQJTZlJZR
    sfstzPGRRBSngMfQLNNqgWLQLZZNgq
    scVDjjjCDTVhHlDhHdvvjwjHrZmWQmJmrJJWqNqLJbrcQqZq
    VvHlVHldTjvhpVplhVThhwjlPFSzPfGzpGBnsRffRRBPPGGF
    WNFNfnWTSLSJTnWShTvVZCnvrdPrZvddVCrt
    QwsMjppcpHCPdHsvPZ
    lcwMGgpcGbzQpMgQwbDjDQZSJTRfShffWNJSSNFFbhSb
    JDNgTgqDTggQbQGbZDWbJmVJrPVfPjlPfPwlljJC
    FZzHFSznZZtptHzcSmCVrwfPVcwwVrCcdm
    nMSStvnZFSHpLLtBtMzHnMWQvNhgDgGNRGNhgqRWTgqg
    SJcrhvbBLBLrDpllvnwHQRnllHnQ
    ffsjfMMZfVdCCgCfgTzmzslRtwFwFtTnqqHTJRQnqRqq
    CVPgmdggVjCJSrhrbrPrrSLW
    LPtcLtgddLMRRCMRpTBRrZnppvvGRvBw
    WNNJjDjqSjJSqWqzNqzlSlBTGGFvrppSrwTFpn
    qbNDWNNHbJqVtctwVmsfLCLP
    FvSSLMqgvVSQjQfgwpwWpj
    BthszRPRRNbNtzmHRbHNRNPfwJGcsswWQpffJpfsJcQFwJ
    bBtzPmRrbBRHtNCzPhqdCLFMLSSvdnvCTnML
    VPHWJPDjVLDDjDSFDJhgdnNGdbblzTzNjlnNbl
    ZprsRZMQwwmGZsvtQZgTfggqnbfdTzrbqlTd
    GZMtsscmsRZswwBQHBhDDJJPPCPWSWCJ
    mNDNNmmVMSVgGgGGqsqGLhQqsLGhLq
    nZBTZpJPhCpnnrsqbbcfczJfFccz
    HpBZZRPRHjnPPjrHnRtCZnBdShDVlMDNDgVmtmDdVDWSdN
    tBftztmztGBBCBSGHBmhvHHcchbshhThpbLJHJ
    wwzMrrMnQdldVdMvJTcLNnphphbLJv
    ZzwPVrWQlwrdStGGCWqDSSGW
    QwfrQPvhwPfzQrvWWpQpvVGGTDGsjbgNNcbfsGTsDFgG
    CtddSdZMRRdnJhRnHtZtlRMbGGDjDgggjNTZDNgTGFgGjc
    mdmdCnHhVWmLmwwL
    zLcWSWFcPJLWrWLSZrJLjVjHtjVsrdtstHdtVQgg
    nChlwwnmhlCNqhhjHMgDjVVdwMjdtd
    CNnBmNNThhhdhCdlBGGlGvNpcJbJLSbcZzcFJzpJTWPbzc
    LdPZTPVpLCVTtCNsNsfFnlDC
    SMwqcqcWQMbMhWQzBnsNfsFwrnnNNlrs
    WMMWhvQRNNNjvLgZ
    DWFGzrtfsZHZZMLt
    pNwNzNCNTpppmnvNMTLVjHLBLLjMRTLH
    PPdlPmJJNNClDdcdDDfWhzrW
    nSJVSHQQnwLThnhrML
    ddsjfRdGZjmGjRTwwTZhwrMwWwtb
    qCdfRdMmgssPfjsdjdPspBzQpScSSCBpzNBQzcQz
    fJnmRMJrlrmRmTRmbqssWVdqNVQdswdNNb
    GZggFHGhHHgHSFvtHPPPsfwgwNsVqjqNpNjNNssN
    PPSPDDBPBmBMlLfmLr
    BdqdCBqqCVPVTZBrlJcTcTJTcfcbwwmcgv
    WjGGLzLMhpWQmRGhpHfbhcDhHHHhgcsbJD
    tQzSGjWRzWBntntrZmVB
    clfLQLgfzfTLDMwNrNrrNDGCGG
    tmbpFtBvvmvdQQdFQwMJCG
    SnbtnqnSbnQQsBqzgLgVsLZTLTPfVg
    QnQBQQBVzqqzpmfgBpnqSDFPjhhWsFVhlsFFsDstFs
    MGGrTHcvRTTrrrCDpjvWtFPlFlsvjp
    bZbpTpJJBBQmBmJf
    dNVgDdVtPcNPhgTLPLpTPlnTHHRn
    WrvjvwjWwfwWjGJsrwBjQJjTQLbnSTTmpTRQSTClHTbLmn
    JqWWGvBJBwGJfJJGvwqZZddFtDFhgDqZhHNM
    VwJcNgbfvfJbfcmGLZfPhZLfZGTDhP
    CnnrlBlprsBnzQFntnZLqDhZZqThWGtWWSPL
    FllFdCjzlsCzjJNJGGJwHHVg
    fTbVBmNJCJRVbTmbfJFHsDjQHDHQjnQRsvDn
    cLWcrGtttddMPhrPhPtPrtzsnSQQBvHjFpFSpDHsMjnvjD
    PrPgPdhGWLrrqgdqcVCffbNblBwfVmwqwC
    gmBfbmlbBDqrdfrDcJ
    PwVWrQphQWWhQsJFcMPqzDdcJq
    QWCSSHpSQWCttQpCRCHNSlZBtrmBZTjvGgZjmBZjBn
    JrnhMPvtVtPVHJGrBrQwTmQmRGGB
    pSSZCFClCbbSLbljZlSlFFszzBwcZNwTzQNDmBwGTBNTBz
    ldsCCjpFjCqdLgsFjpsLFQgtnfqtJvnMtnvhWnHHMnnVWV
    hzNHzHjWNzwHjjhprpGvGgvGvvpv
    PLBVVRPDLdrgCdMrdrdC
    FmBTqTmLPrsFqTBDcTTVtNNJztqWQNQtWWtJqNNz
    fFffFvFBgHQWHdvfGglBWbqbPSSbSwVntPhZwwbS
    jJCMzNMCjNCLNMjjphPSPqhbqnwPZLSqZh
    rNpJJDzpcNMzzdBnGcQTccBvgv
    FRFMwsrzVtwstgbCHHJJPgNb
    hfZGhZDnnTTHTCCNzJjH
    hppDvznmZphZQVFQwFVWlRqFls
    jrjrgdHdFBZsBlcCGghWNgpgbCCp
    QwJJqQQMLwPTwLMMwzvzwwzhCWbvcNcCChWpchWbNGfFff
    qqFQJTmwJSPjZsrlnBjdHm
    QfffRppWfHpQSrWVpSGmGMMccSjBjmmGmc
    qdzLvbwzwdsWwnFdBBcBhMjMDvBBcBhc
    bPdZPqddqzFsZVRptZZQHVWNpN
    BzBQQHNjTSzzJDDFZFgJDJ
    qLvCnLpfCpqCnLJhntRglFncDrGrllmZFZlDrc
    JpqvfhRhLddfpbbtsdJWjHSwHHTNSQNPTVHQTb
    qVQCCVlQZWgHZMqgqWlrtScFwrmtmcJqSSsSJS
    MzdnddpNLzhRpzbzNPPBbPScjcnmrwSFjSjSJFtrwjcF
    ddTzRMPLdLbvhBRdLWGQClVVCWQZQDTGGf
    DHHTsldDNdPnVDCRDCNHllHwcMpprSMpRmphhRWhrhmzSS
    qJLBqQLvJLQgftgPjJrhrMMWSmWMmMrrSqrc
    FjfFftgLBjJPBLQZGvvZtNClnTTNGCdHTbCCNsnslH
    jHHNsNqhjsShsshdRRCDMfMbCWHBrGGC
    TJQFmnpgmTpBDCgCMCDZCGDC
    FwpQzwQTmVvwTJmFJzTcQSdhBNztNPNjSlqLhBNhSh
    vBCfSDcRMfRcRHSRRZZtPwrWWNtdSmrNVGSdwm
    gbLnTzqTbjhGqFzgWrtttQtrPQTtNPmP
    zbhjzglgzzlBGcsflsCl
    jNHDNNHjVGVDNQFDTQSFZzDQTd
    vvLwhbnpvPPgClwnfFTmTZQgffFFtTfc
    LrhrLvwrnJvhCHVVRZNMjsRJVB
    ShfcBWfvdhhJBBVwCJjHTRNwRVNC
    qQzlDqMDDDslPqGVLTNZVpPwTRZZpV
    bgbDbsqzsDTcfrgFFdgg
    vlRHvvHwvMMMTTlvjmRtBjSJmSnDnpdrpSSrJJnDQrLp
    cPfCgZZzNzzcGhNszcTPNZLrnVSJpJhDrrhSSQSpDDQn
    FbTgbGcgNgcFbPFHMqvjjRtjRWvFvt
    fZTnqfFFDNglcjdjZcfLGQJBwrGGQwbGQTBBJz
    VhvfvsPpWRChmphvRGBbBLGhSbLrBQBSwb
    pCsCsHvsstPsfRMMMtmDqFjngdFZqDHFnNFFjl
    PVVwffMlfGWMDDSwfDwVpRpsZRjBHgpSsjJSpBSp
    TdnFbqTFdmbjctcqcbRBZtJJZgsBzBBzvgHJ
    bNmbcqnnbNFLChCVCfjDfWlMjVDPCr
    JBLLjBQccLLJhcBDDlSrdFDsVhrVsR
    HgNWCgqWGbvCRRZvGWvZmszsSlrWdSdFrWzSldDF
    qvGCZGHggRNHvGTgvLnBjpjjPJwTPjLcJj
    GCGwQrwBZMZdGVdLzbqbbp
    TRfTTCtgcDmhtDmsTDVSbvpLdNpzNVRqVdVL
    CfDJjscgTcsjfhtFZljPZWZMWPlZjQ
    WsrjjfRfjjZjwjWjBpDpVpVhMBsMMSBT
    JgmqHnCHHPCCtCJgSZMgZppDTgzvzZMz
    HCGCGqqqCtmnHnqLFHWjlFrWRRbfjZccNWrR
    BJBfSfPLPvdhvrbbvpDsHgDTzgpdzgZpgN
    cVcmRnCWCqGngHpZsZsTsqNN
    jmGCVwWjjnWFMjGwcwmrLJbBJPbLSrPPTbFBTr
    SPZmmtlmqjZlZMwhlrtggqGGcCLCpfGLgqdCqF
    FBBVDVTVDJfgcddLCDdp
    zzVHvVNTbWJJTTRbVWBFJbWHmwmSPlMjPSShjlhMhhrrml
    GJZJZTsnhsDJtVZdtsZJZrBCQpLjQgBnrQgjCjQQQj
    RPSfqcRShHbFcPSfBqLLprBCwrQQQCqg
    zPzPRHbFPcRRRHPclMhSfvfZsJZVTTZsJNVMGWGVdGTWWD
    lCZrCLWCwVllGzWPPBMTFpsbGdsTpsbNMgFb
    RDjtjHcHjcHctDRtjnhtnHTgMqTMqhTbdbdZbgFqZdMN
    vfDmvfjtmvtcHmjZfSRZHQzBLrVLCJLJLfJBPzVJlwPw
    JMTHVZMWNSCwCwMS
    nsddQbDCnQQdDBPdCQCSvwpDvwffhfSvpmppvp
    BssqBFtqRHgTqVRC
    cWTTthtrgrzpCdCddtpz
    SSSLNJLGLSLfCJfJFQCJzQ
    swMPMZVMMSlMSZMqVSSHznzcqgzWTHgTnhbnrr
    RJjjgMjWShPqchtbVBPV
    DDddwCnZMHLLvDnfLrvvbVbbBtpwVBVPwtVpbcbb
    zrvnvLrlZCHrfZZLffHZHHTsTmsQgFQSFTMjjQlFTRmR
    zhTTMLRVTzLbVqwVRJgDQQsSCgCDNgsZCpqp
    rrmrBmmWrWnHjWnGWrnGnhDHSQgNSpQsCgSNgtNtDDHZ
    fBrGPGmGPBcTMfLhJVTc
    TbTCjTBSbCncHsDZDZPhZbzv
    rMwplFdlWWJMJzhhpGtHtvHSSP
    fMMfwWdWrNfJNdlVgMcTLTmLffjTqnLScCjL
    SwhTllwJDwqqBWLBbNtfhjBB
    mvllZMmRMZGFZRfctLWtWttzfNLR
    MGvHMCGpVnFGlgvVFFnpnGmmsHrDJJdSsqPqJSqDJJdTTDqD
    QTTcqJZJhHSpShhFpFzjDDwwsFzpdg
    NBMnBvmBPvwrqvgvvqgD
    bNNGmWmbbClQTQRqchhQbf
""".trimIndent()
